' ========================================================================================
' GdipGetRegionScansI
' ========================================================================================

' SED_PBWIN
#COMPILE EXE
#DIM ALL
#INCLUDE "GDIPLUS.INC"

%IDC_GRAPHIC = 101

SUB GDIP_GetRegionScansI (BYVAL hdc AS DWORD)

   LOCAL hStatus AS LONG
   LOCAL pGraphics AS DWORD
   LOCAL pPath AS DWORD
   LOCAL pSolidBrush AS DWORD
   LOCAl pPen AS DWORD
   LOCAL pPathRegion AS DWORD
   LOCAL pMatrix AS DWORD
   LOCAL count AS LONG
   LOCAL j AS LONG
   DIM   rects(0) AS RECTL

   hStatus = GdipCreateFromHDC(hdc, pGraphics)
   hStatus = GdipCreateSolidFill(GDIP_ARGB(255, 255, 0, 0), pSolidBrush)
   hStatus = GdipCreatePen1(GDIP_ARGB(255, 0, 0, 0), 1.0, %UnitWorld, pPen)
   hStatus = GdipCreatePath(%FillModeAlternate, pPath)
   hStatus = GdipCreateMatrix(pMatrix)

   ' // Create a region from a path.
   hStatus = GdipAddPathEllipseI(pPath, 10, 10, 50, 300)
   hStatus = GdipCreateRegionPath(pPath, pPathRegion)

   ' // Get the rectangles.
   hStatus = GdipGetWorldTransform(pGraphics, pMatrix)
   hStatus = GdipGetRegionScansCount(pPathRegion, count, pMatrix)
   REDIM rects(count - 1)
   hStatus = GdipGetRegionScansI(pPathRegion, rects(0), count, pMatrix)

   ' // Draw the rectangles.
   FOR j = 0 TO count - 1
      hStatus = GdipDrawRectangleI(pGraphics, pPen, rects(j).nLeft, rects(j).nTop, rects(j).nRight, rects(j).nBottom)
   NEXT

   ' // Cleanup
   IF pMatrix THEN GdipDeleteMatrix(pMatrix)
   IF pPen THEN GdipDeletePen(pPen)
   IF pPathRegion THEN GdipDeleteRegion(pPathRegion)
   IF pSolidBrush THEN GdipDeleteBrush(pSolidBrush)
   IF pPath THEN GdipDeletePath(pPath)
   IF pGraphics THEN GdipDeleteGraphics(pGraphics)

END SUB
' ========================================================================================

' ========================================================================================
' Main
' ========================================================================================
FUNCTION WinMain (BYVAL hInstance AS DWORD, BYVAL hPrevInstance AS DWORD, BYVAL lpszCmdLine AS ASCIIZ PTR, BYVAL nCmdShow AS LONG) AS LONG

   LOCAL hr AS LONG
   LOCAL hDlg AS DWORD
   LOCAL hdc AS DWORD
   LOCAL token AS DWORD
   LOCAL StartupInput AS GdiplusStartupInput

   ' Initialize GDI+
   StartupInput.GdiplusVersion = 1
   hr = GdiplusStartup(token, StartupInput, BYVAL %NULL)
   IF hr THEN
      MSGBOX "Error initializing GDI+"
      EXIT FUNCTION
   END IF

   ' Create a new dialog
   DIALOG NEW PIXELS, 0, "GdipGetRegionScansI", , , 400, 320, %WS_SYSMENU TO hDlg

   ' Add a graphic control
   CONTROL ADD GRAPHIC, hDlg, %IDC_GRAPHIC,"", 0, 0, 400, 320
   ' Select the drawing target
   GRAPHIC ATTACH hDlg, %IDC_GRAPHIC
   ' Set the foreground and background color
   GRAPHIC COLOR %BLACK, %WHITE
   ' Clear the entire selected graphic window
   GRAPHIC CLEAR
   ' Retrieve the handle of the device context
   GRAPHIC GET DC TO hdc
   ' Draw the graphics
   GDIP_GetRegionScansI hdc

   DIALOG SHOW MODAL hDlg, CALL DlgProc

   ' Shutdown GDI+
   GdiplusShutdown token

END FUNCTION
' ========================================================================================

' ========================================================================================
' Main Dialog procedure
' ========================================================================================
CALLBACK FUNCTION DlgProc() AS LONG

   SELECT CASE CBMSG

      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDCANCEL
               IF CBCTLMSG = %BN_CLICKED THEN DIALOG END CBHNDL, 0
         END SELECT

   END SELECT

END FUNCTION
' ========================================================================================
